<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<title>BWInfo Composite object sample</title>
</head>

<body>
<%
    If Request("RegComp").Count > 0 Then
        Set cc = Server.CreateObject("newObjects.utilctls.VaryDispCreator")
        cc.RegisterClass Server.MapPath("browserinfo/bwinfo.comp")
        %><B>The bwinfo.comp has been registered.</B><%
    End If
%>
<p>This sample illustrates how to build a composite component using VBScript and
some existing components from the AXPack1 family (the ALP run-time library).</p>
<p><b>The component</b></p>
<p>The component in this sample is quite simple, yet one needs to perform such
tasks very often - check the browser type and version. This component translates
the information in more convenient form and provides special translation
concerning the ALPFrame browser. In other words you may need this component or
something like it if you want to port ALP application that employs ALPFrame
browser features to a WEB server.&nbsp;</p>
<p>The component implementation is in the <b>browserinfo</b> subdirectory. To
illustrate the opportunities it exists there in two forms - source and
packed.&nbsp;</p>
<p><b>The source form</b>&nbsp;</p>
<p>It involves the <b>browserinfo.comp</b> and the <b>browserinfo.vbs</b> files.
The <b>browserinfo.comp </b>file is the composite definition file which defines
the component ClassID and ProgID, the script and the other COM objects needed to
construct it and the member mappings.&nbsp;</p>
<p><b>The packed form</b></p>
<p>It is created using the Developer tools installed with ALP (see Start
menu-&gt;Programs-&gt;newObjects-&gt;ALP-&gt;Developer tools). The
&quot;Composite definition converter&quot; allows you specify a composite
definition file (<b>browserinfo.comp </b>in this sample) and produce new
definition file in binary format which contains not only the definition but also
all the scripts involved in a single file. The packed form in this sample is <b>bwinfo.comp</b>.</p>
<p><b>The test pages</b></p>
<p>There are 3 pages that use the component described above. They all do the
same - list all the information supplied by it. However they invoke the
composite object in different manners. The first two pages use &lt;OBJECT RUNAT=SERVER
...&gt; and Server.CreateObject respectively in the regular manner. I.e. they
create the object by ProgID. These two pages will fail with an error if the
composite object is not registered with the system as normal COM object.
Initially (after the ALP installation) this object is not registered and you
will need to do so yourself. You can use the Developer tools mentioned above and
specify whichever composite definition file you want in the &quot;Composite
register/unregister utility&quot; or you can click this <a href="default.asp?RegComp=1">link</a>
to invoke the component registration by this page.</p>
<p>Note that you can specify the source form or the packed form. I.e. the
composite objects may work in non-packed/non-compiled form which is convenient
feature during the development process. Once the component development is
complete you can pack the composite object in a single file and distribute it.</p>
<p><a href="test-reg1.asp">test-reg1.asp</a> - uses &lt;OBJECT RUNAT=SERVER
...&gt; to create the object</p>
<p><a href="test-reg2.asp">test-reg2.asp</a> - uses Server.CreateObject to
create the composite object.</p>
<p>The 3-d test page <a href="test-noreg.asp">test-noreg.asp</a> creates the
composite object in quite different manner. It creates it directly from the
composite definition file. You will notice the line:</p>
<p>Set bwinfo = Server.CreateObject(Server.MapPath("browserinfo/bwinfo.comp"))</p>
<p>in this page. The Server.MapPath is used to obtain the full physical path to
the composite definition. Thus this page does not need the component to be
registered in order to work. However there is something you must be aware of! By
default ALP's Server.CreateObject is configured to not support this feature. The
ALP Application settings must be adjusted to enable the feature. This is done in
the asp file extension settings - &quot;Extended CreateObject&quot; checkbox. To
see the configuration used in this sample open its directory in Windows
Explorer, right click somewhere in the folder window and choose &quot;ALP
Settings&quot; from the Windows context menu. Then go to the ALP application
settings and click Edit for asp extension.</p>
<p>This feature is not enabled by default for two reasons - performance and IIS
compatibility. Obviously the Server.CreateObject needs to perform more
processing in order to determine how to treat the passed parameter - as ProgID
or as path. The IIS compatibility is more important - this wont work under IIS
and the developer must be aware of this before enabling the feature.</p>
<p><b>The composite object in this sample is an ASP object</b>&nbsp;&nbsp;</p>
<p>If you open the composite definition file <b>browserinfo.comp </b>in a text
editor you will notice that it maps OnStartPage and OnEndPage methods to methods
in the implementation script. This means that the object is especially designed
to work in ASP compatible environments thus minimizing the developer efforts. In
this case the benefit is quite obvious - the information is collected and parsed
during the object creation and the developer just needs to inspect the object's
properties and collection to get data he/she needs. No efforts are needed to
pass ASP supplied information to the object - it will get it on its own.</p>
<p>Will this work in both ALP and IIS? The answer is yes for the techniques used
in the <a href="test-reg1.asp">test-reg1.asp</a> and <a href="test-reg2.asp">test-reg2.asp</a>
pages and no for the 3-d page which uses ALP specific extension. For the
functionality provided by the composite object in this sample the usage
demonstrated in <a href="test-noreg.asp">test-noreg.asp</a> is not important,
but for other components doing something else this may be very convenient. For
instance in autorun applications (applications that are designed to run without
installation) this will be the only way to use your own composite objects if you
really want to avoid any installation process. Of course, this means that such
an autorun application will be at least especially adapted for ALP if not
entirely built to run only in ALP environment for autorun makes no sense in a
WEB server environment. But in case of other types of applications you may want
to run them under ALP and under IIS as well. In such case if you register the
composite on the machine where the application will work and use it in the
manner shown in <a href="test-reg1.asp">test-reg1.asp</a> and <a href="test-reg2.asp">test-reg2.asp</a>
samples - there will be no difference between IIS and ALP.</p>
<p><b>Conclusion</b></p>
<p>While the Composite objects technology is ours it can be used for
applications that will target not only ALP environment. This sample shows that
even ASP objects that are especially designed to query the ASP engine directly
without help from the ASP page can be created and used with ALP and IIS. This
means that you can depend on the Composite objects technology without doubts for
the platform compatibility.</p>
<p><b>What are the Composite objects requirements?</b></p>
<p>On a machine where you are going to use composite objects you must have only
the ALP run-time library installed (in ALP autoruns the library is present by
default). For example on IIS machine where you are going to use such objects you
will need to download and install <a href="http://www.newobjects.com/axpack1">newObjects
ActiveX Pack1 Family</a> which is the ALP run-time library packed for
distribution without ALP.</p>
<p>Do not forget that if you are using 3-d party components in your
implementation they will be needed as well.</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>

</body>

</html>
